MCP Tools Reference: iam.googleapis.com

Tool: get_access_policy

Gets the details, metadata, and rules of a Unified Access Policy. Only supports Unified Access Policies that are parented by a project.

Use this tool to inspect the policy rules and configuration of a specific Unified Access Policy.

This tool requires the name parameter, which is the resource name of the Unified Access Policy to retrieve. Only projects are supported. The format is projects/PROJECT_ID/locations/LOCATION/accessPolicies/POLICY_ID.

This tool returns the details and configuration of the specified Unified Access Policy, including its rules and etag.

The following code sample shows how to use curl to call the get_access_policy MCP tool.

Curl Request
curl --location 'https://iam.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "get_access_policy",
    "arguments": {
      // Provide these details according to the MCP tool specification.
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'

Input Schema

Request message for GetAccessPolicy method.

GetAccessPolicyRequest

JSON representation
{
  "name": string
}
Fields
name

string

Required. The name of the Unified Access Policy to retrieve.

Format: * projects/{project_id}/locations/{location}/accessPolicies/{unified_access_policy_id} * projects/{project_number}/locations/{location}/accessPolicies/{unified_access_policy_id} * folders/{folder_id}/locations/{location}/accessPolicies/{unified_access_policy_id} * organizations/{organization_id}/locations/{location}/accessPolicies/{unified_access_policy_id}

Output Schema

An IAM Unified Access Policy resource.

AccessPolicy

JSON representation
{
  "name": string,
  "uid": string,
  "etag": string,
  "displayName": string,
  "annotations": {
    string: string,
    ...
  },
  "createTime": string,
  "updateTime": string,
  "details": {
    object (AccessPolicyDetails)
  }
}
Fields
name

string

Identifier. The resource name of the Unified Access Policy.

The following formats are supported:

  • projects/{project_id}/locations/{location}/accessPolicies/{unified_access_policy_id}
  • projects/{project_number}/locations/{location}/accessPolicies/{unified_access_policy_id}
  • folders/{folder_id}/locations/{location}/accessPolicies/{unified_access_policy_id}
  • organizations/{organization_id}/locations/{location}/accessPolicies/{unified_access_policy_id}
uid

string

Output only. The globally unique ID of the Unified Access Policy.

etag

string

Optional. The etag for the Unified Access Policy. If this is provided on update, it must match the server's etag.

displayName

string

Optional. The description of the Unified Access Policy. This description can be a maximum of 63 characters.

annotations

map (key: string, value: string)

Optional. User-defined annotations. See https://google.aip.dev/148#annotations for more details such as format and size limitations.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

createTime

string (Timestamp format)

Output only. The time when the Unified Access Policy was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. The time when the Unified Access Policy was most recently updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

details

object (AccessPolicyDetails)

Optional. The details for the Unified Access Policy.

AnnotationsEntry

JSON representation
{
  "key": string,
  "value": string
}
Fields
key

string

value

string

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

AccessPolicyDetails

JSON representation
{
  "rules": [
    {
      object (AccessPolicyRule)
    }
  ]
}
Fields
rules[]

object (AccessPolicyRule)

Required. A list of Unified Access Policy rules.

AccessPolicyRule

JSON representation
{
  "principals": [
    string
  ],
  "excludedPrincipals": [
    string
  ],
  "operation": {
    object (Operation)
  },
  "conditions": {
    string: {
      object (Expr)
    },
    ...
  },

  // Union field _description can be only one of the following:
  "description": string
  // End of list of possible types for union field _description.

  // Union field _effect can be only one of the following:
  "effect": enum (Effect)
  // End of list of possible types for union field _effect.
}
Fields
principals[]

string

Required. The principals to include in the rule. This field can contain the following values:

  • principal://goog/subject/{email_id}: A specific Google Account. Includes Gmail, Cloud Identity, and Google Workspace user accounts. For example, principal://goog/subject/alice@example.com.

  • principal://iam.googleapis.com/projects/-/serviceAccounts/{service_account_id}: A Google Cloud service account. For example, principal://iam.googleapis.com/projects/-/serviceAccounts/my-service-account@iam.gserviceaccount.com.

  • principalSet://goog/group/{group_id}: A Google group. For example, principalSet://goog/group/admins@example.com.

  • principalSet://goog/cloudIdentityCustomerId/{customer_id}: All of the principals associated with the specified Google Workspace or Cloud Identity customer ID. For example, principalSet://goog/cloudIdentityCustomerId/C01Abc35.

  • principalSet://goog/public:all: A special identifier that represents any principal that is on the internet, even if they do not have a Google Account or are not logged in. This value is only supported in rules with the DENY effect.

  • principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}: A single identity in a workforce identity pool.

  • principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/group/{group_id}: All workforce identities in a group.

  • principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/attribute.{attribute_name}/{attribute_value}: All workforce identities with a specific attribute value.

  • principalSet://iam.googleapis.com/locations/global/workforcePools/{pool_id}/*: All identities in a workforce identity pool.

  • principal://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/subject/{subject_attribute_value}: A single identity in a workload identity pool.

  • principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/group/{group_id}: A workload identity pool group.

  • principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/attribute.{attribute_name}/{attribute_value}: All identities in a workload identity pool with a certain attribute.

  • principalSet://iam.googleapis.com/projects/{project_number}/locations/global/workloadIdentityPools/{pool_id}/*: All identities in a workload identity pool.

  • principal://{trust_domain}/{agent_resource_path}/{agent_id}: A single, specific agent identity.

  • principalSet://{trust_domain}/*: All agent identities that belong to a particular trust domain.

  • principalSet://{trust_domain}/attribute.{attribute_name}/{attribute_value}: All agents with a particular attribute.

If an identifier that was previously used in a rule is soft deleted, then a deleted prefix is automatically added to the identifier. Users can't add new identifiers with this syntax.

  • deleted:principal://goog/subject/{email_id}?uid={uid}: A specific Google Account that was deleted recently. For example, deleted:principal://goog/subject/alice@example.com?uid=1234567890. If the Google Account is recovered, this identifier reverts to the standard identifier for a Google Account.

  • deleted:principalSet://goog/group/{group_id}?uid={uid}: A Google group that was deleted recently. For example, deleted:principalSet://goog/group/admins@example.com?uid=1234567890. If the Google group is restored, this identifier reverts to the standard identifier for a Google group.

  • deleted:principal://iam.googleapis.com/projects/-/serviceAccounts/{service_account_id}?uid={uid}: A Google Cloud service account that was deleted recently. For example, deleted:principal://iam.googleapis.com/projects/-/serviceAccounts/my-service-account@iam.gserviceaccount.com?uid=1234567890. If the service account is undeleted, this identifier reverts to the standard identifier for a service account.

  • deleted:principal://iam.googleapis.com/locations/global/workforcePools/{pool_id}/subject/{subject_attribute_value}: A workforce identity that was deleted recently. For example, deleted:principal://iam.googleapis.com/locations/global/workforcePools/my-pool-id/subject/my-subject-attribute-value. If the workforce identity is undeleted, this identifier reverts to the standard identifier for a workforce identity.

excludedPrincipals[]

string

Optional. The principals to exclude from the rule, even if they are listed in the principals. For example, you could add a Google group to the principals, then exclude specific users who belong to that group.

operation

object (Operation)

Required. Attributes that are used to determine whether this rule applies to a request.

conditions

map (key: string, value: object (Expr))

Optional. The conditions that determine whether this rule applies to a request. Conditions are identified by their key, which is the FQDN of the service that they are relevant to. For example:

"conditions": {
 "iam.googleapis.com": {
  "expression": {cel_expression}
 }
}

Each rule is evaluated independently. If this rule does not apply to a request, other rules might still apply. The following keys are supported:

  • eventarc.googleapis.com: Can use CEL functions that evaluate resource fields.

  • iam.googleapis.com: Can use CEL functions that evaluate resource tags and combine them using boolean and logical operators. Other functions and operators are not supported.

  • iap.googleapis.com: Can use CEL functions and attributes that evaluate destination resources for requests that use the iap.googleapis.com/resources.egressViaIAP permission.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

Union field _description.

_description can be only one of the following:

description

string

Optional. Customer-specified description of the rule. This description can be a maximum of 256 characters.

Union field _effect.

_effect can be only one of the following:

effect

enum (Effect)

Required. The effect of the rule.

Operation

JSON representation
{
  "permissions": [
    string
  ],
  "excludedPermissions": [
    string
  ]
}
Fields
permissions[]

string

Optional. The permissions to include in the rule. Rules with the ALLOW effect grant the specified permissions. Rules with the DENY effect deny the specified permissions.

The following formats are supported:

  • Individual permissions: Individual permissions use the format {service_fqdn}/{resource}.{verb}, where {service_fqdn} is the fully qualified domain name for the service. For example, eventarc.googleapis.com/messageBuses.publish.
  • Roles: Only supported in rules with the ALLOW effect. Roles use the format role:{role_name}. For example, role:roles/logging.logsViewer. If you include a role name in a rule, then the rule includes all of the permissions in that role.
  • Permission groups: Sets of permissions, such as aiplatform.googleapis.com/*.*. Permission groups are sets of permissions that match a specified pattern. There are some restrictions on the permission groups you can reference and the permissions included in those groups. For more information, see Permission groups.

An empty list doesn't match any permissions.

excludedPermissions[]

string

Optional. Specifies the permissions to exclude from the rule. If a permission appears in permissions and in excluded_permissions, then it will not be subject to the rule effect.

The excluded permissions can be specified using the same syntax as permissions.

ConditionsEntry

JSON representation
{
  "key": string,
  "value": {
    object (Expr)
  }
}
Fields
key

string

value

object (Expr)

Expr

JSON representation
{
  "expression": string,
  "title": string,
  "description": string,
  "location": string
}
Fields
expression

string

Textual representation of an expression in Common Expression Language syntax.

title

string

Optional. Title for the expression, i.e. a short string describing its purpose. This can be used e.g. in UIs which allow to enter the expression.

description

string

Optional. Description of the expression. This is a longer text which describes the expression, e.g. when hovered over it in a UI.

location

string

Optional. String indicating the location of the expression for error reporting, e.g. a file name and a position in the file.

Effect

An effect to describe how the rule affects access.

Enums
EFFECT_UNSPECIFIED The effect is unspecified.
DENY The rule will deny access if it evaluates to true.
ALLOW The rule will grant access if it evaluates to true.

Tool Annotations

Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.

Along with the title string, the following boolean hints are defined as follows:

  • readOnlyHint: If true, the tool doesn't modify its environment. Default: false.
  • destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
  • idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
  • openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌